﻿Public Class Form1
    Dim Backdir As String
    Dim savedir As String
    Dim version As String
    Dim blueprint As String
    Dim exe As String
    Dim backupqty As Integer
    Dim startup As Boolean = True
    Dim windowsettings As New WindowSettings
    Private Sub btnStart_Click(sender As Object, e As EventArgs) Handles btnStart.Click
        If checkdir(txtBackupDirectory.Text) = False Then
            MsgBox("Backup directory does not exist or is inaccessible!", MsgBoxStyle.Exclamation)
            Exit Sub
        End If
        If checkdir(txtSaveDirectory.Text) = False Then
            MsgBox("Save directory does not exist or is inaccessible!", MsgBoxStyle.Exclamation)
            Exit Sub
        End If
        If checkpath(txtExe.Text) = False Then
            MsgBox("Invalid path to Factorio.exe!", MsgBoxStyle.Exclamation)
            Exit Sub
        End If
        If checkint(txtBackupQty.Text) = False Then
            MsgBox("Backup quantity must be an integer!", MsgBoxStyle.Exclamation)
            Exit Sub
        End If
        Backdir = txtBackupDirectory.Text
        savedir = txtSaveDirectory.Text
        exe = txtExe.Text
        backupqty = txtBackupQty.Text
        Dim savedirparse As List(Of String) = savedir.Split("\").ToList
        savedirparse.RemoveAt(savedirparse.Count - 1)
        blueprint = ""
        Dim log As String = ""
        For Each line In savedirparse
            blueprint &= line & "\"
            log &= line & "\"
        Next
        blueprint &= "blueprint-storage.dat"
        log &= "factorio-current.log"
        If checkpath(log) Then
            Dim fs As IO.StreamReader = IO.File.OpenText(log)
            version = fs.ReadToEnd
            version = version.Remove(version.IndexOf(" (build"))
            version = version.Remove(0, version.IndexOf("Factorio ") + 9)
            version = version.Replace(".", "_")
            fs.Close()
        End If
        My.Settings.BackupDir = Backdir
        My.Settings.SaveDir = savedir
        My.Settings.Exe = exe
        My.Settings.Backups = backupqty
        My.Settings.Blueprints = chkBlueprints.Checked
        My.Settings.Save()
        Dim datetime As String = Now.ToString("yyMMdd HHmmss")
        Dim backdirtemp As String = Backdir & "\" & datetime & " " & version
        My.Computer.FileSystem.CopyDirectory(savedir, backdirtemp & "\saves")
        If chkBlueprints.Checked = True Then My.Computer.FileSystem.CopyFile(blueprint, backdirtemp & "\blueprint-storage.dat")
        Dim backuplist As List(Of String)
        backuplist = IO.Directory.GetDirectories(Backdir).ToList
        Do While backuplist.Count > backupqty
            IO.Directory.Delete(backuplist.First, True)
            backuplist.RemoveAt(0)
        Loop
        Process.Start(exe)
        End
    End Sub
    Function checkdir(dir As String)
        If IO.Directory.Exists(dir) Then
            Return True
        Else
            Return False
        End If
    End Function
    Function checkpath(path As String)
        If IO.File.Exists(path) Then
            Return True
        Else
            Return False
        End If
    End Function
    Function checkint(int As String)
        For i = 0 To 9
            int = int.Replace(i, "")
        Next
        If int = "" Then
            Return True
        Else
            Return False
        End If
    End Function
    Private Sub btnBackupDirectory_Click(sender As Object, e As EventArgs) Handles btnBackupDirectory.Click
        txtBackupDirectory.Text = folderbrowser(txtBackupDirectory.Text)
        Backdir = txtBackupDirectory.Text
    End Sub
    Private Sub btnSaveDirectory_Click(sender As Object, e As EventArgs) Handles btnSaveDirectory.Click
        txtSaveDirectory.Text = folderbrowser(txtSaveDirectory.Text)
        savedir = txtSaveDirectory.Text
    End Sub
    Private Sub btnExe_Click(sender As Object, e As EventArgs) Handles btnExe.Click
        txtExe.Text = filepicker(txtExe.Text)
        exe = txtExe.Text
    End Sub
    Function folderbrowser(path As String)
        If checkdir(path) Then FolderBrowserDialog1.SelectedPath = path
        If FolderBrowserDialog1.ShowDialog() = DialogResult.OK Then
            Return FolderBrowserDialog1.SelectedPath
        Else
            Return path
        End If
    End Function
    Function filepicker(path As String)
        If checkpath(path) Then
            OpenFileDialog1.InitialDirectory = path.Remove(path.LastIndexOf("\"))
            OpenFileDialog1.FileName = path.Remove(0, path.LastIndexOf("\") + 1)
        Else
            OpenFileDialog1.InitialDirectory = "C:\"
            OpenFileDialog1.FileName = ""
        End If
        OpenFileDialog1.Filter = "Applications|*.exe"
        OpenFileDialog1.RestoreDirectory = True
        If OpenFileDialog1.ShowDialog() = DialogResult.OK Then
            Return OpenFileDialog1.FileName
        Else
            Return path
        End If
    End Function
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
        windowsettings.Load(sender)
        startup = False
        txtBackupDirectory.Text = My.Settings.BackupDir
        txtSaveDirectory.Text = My.Settings.SaveDir
        txtExe.Text = My.Settings.Exe
        txtBackupQty.Text = My.Settings.Backups
        chkBlueprints.Checked = My.Settings.Blueprints
    End Sub
    Private Sub Form1_ResizeMove(sender As Object, e As EventArgs) Handles Me.Resize, Me.Move
        If startup = False Then windowsettings.Save(sender)
    End Sub
End Class
