﻿Public Class WindowSettings
    Public Sub Save(sender As Object)
        Dim name As String = DirectCast(sender, Form).Name
        If DirectCast(sender, Form).WindowState = FormWindowState.Maximized Then
            My.Settings.Item(name & "Maximized") = True
        Else
            My.Settings.Item(name & "Maximized") = False
            My.Settings.Item(name & "Position") = DirectCast(sender, Form).Location
            My.Settings.Item(name & "Size") = DirectCast(sender, Form).Size
        End If
        My.Settings.Save()
    End Sub
    Public Sub Load(sender As Object)
        Dim name As String = DirectCast(sender, Form).Name
        Dim screenwidth As Integer = SystemInformation.VirtualScreen.Width
        Dim screenheight As Integer = SystemInformation.VirtualScreen.Height
        Dim save As Boolean = False

        DirectCast(sender, Form).WindowState = FormWindowState.Normal

        Dim pos As Point = My.Settings.Item(name & "Position")
        If pos.X > screenwidth Then pos.X = pos.X Mod screenwidth
        If pos.Y > screenheight Then pos.Y = pos.Y Mod screenheight
        If pos.X < 0 Then pos.X = 50
        If pos.Y < 0 Then pos.Y = 50
        DirectCast(sender, Form).Location = pos

        Dim size As Size = My.Settings.Item(name & "Size")
        If size.Width > screenwidth Then size.Width = size.Width Mod screenwidth
        If size.Height > screenheight Then size.Height = size.Height Mod screenheight
        DirectCast(sender, Form).Size = size

        If My.Settings.Item(name & "Maximized") = True Then DirectCast(sender, Form).WindowState = FormWindowState.Maximized

        If My.Settings.Item(name & "Position") <> pos Then save = True
        If My.Settings.Item(name & "Size") <> size Then save = True
        If save = True Then My.Settings.Save()
    End Sub
End Class
